from time import time
import numpy as np

def f(x,y):
    return x*x*x * y *.3 + .3/4. * x*x * y*y*y - y * x *.4

#allocate data
n = 100000
x=np.linspace(1,10,n)
y=np.linspace(1,20,n)

t0 = time()
for i in range(n):
   f(x[i],y[i]) 
t1 = time()
print "numpy(bad):",t1-t0

xl = x.tolist()
yl = y.tolist()
t0 = time()
for i in range(n):
   f(xl[i],yl[i]) 
t1 = time()
print "pure python:",t1-t0


t0 = time()
f(x,y) 
t1 = time()
print "numpy(good):",t1-t0

