import numpy as np
cimport numpy as np
import cython

from cython.parallel import prange

@cython.boundscheck(False)
def f(np.ndarray[double] x,np.ndarray[double]y):
    cdef np.ndarray[double]result = np.empty_like(x)
    cdef int size = x.size
    cdef int i 
    for i in prange(size,nogil=True):
       result[i] = x[i]*x[i]*x[i] * y[i] *.3 + .3/4. * x[i]*x[i] * y[i]*y[i]*y[i] - y[i] * x[i] *.4
    return result
